/* sysklogd-dispatch.h -- 
 * Copyright 2007 Red Hat Inc., Durham, North Carolina.
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Authors:
 *   Steve Grubb <sgrubb@redhat.com>
 *   Peter Vrabec <pvrabec@redhat.com>
 * 
 */

#ifndef SYSKLOGD_DISPATCH_H
#define SYSKLOGD_DISPATCH_H


typedef enum { QOS_NON_BLOCKING, QOS_BLOCKING } qos_t;

struct daemon_conf
{
        char * dispatcher;
        qos_t qos;              /* use blocking/non-blocking sockets */
};

/* Sysklogd protocol #1 contains only one type of reply message
   and that is standart message. */
#define SYSKLOGD_PROTOCOL_VER	1
#define MAXLINE			1024 /* Should be same MAXLINE as in syslogd.c */
typedef enum { STD_MESS } mess_t;   

struct sysklogd_reply {
        mess_t			type;
        int			len;
	union {
	       	const char		*message;
	};
};

struct sysklogd_dispatcher_header {
        int        ver;    /* The version of this protocol */
        int        hlen;   /* Header length */
        mess_t     type;   /* Message type */
        int        size;   /* Size of data following the header */
};


int init_dispatcher(const struct daemon_conf *config);
void shutdown_dispatcher(void);
void reconfigure_dispatcher(void);
void dispatch_event(const struct sysklogd_reply *rep);

#endif
